<?




class CNTagParser extends NodeParser {

 var $d_editMode;

 function CNTagParser() {
 parent::NodeParser(LINKT_TAGPARSER);
 $this->setParseTagParams(false);
 $this->setParseTagResult(true);
 $this->setUseSimpleTags(true);
 $this->initDefaultParser();
 $this->d_editMode = CN_EM_PUBLISH;
 }

 function setBaseObject(&$object) {
 if (!is_a($object,"cntagcollection")) return false;
 return parent::setBaseObject($object);
 }

 function initDefaultParser() {
 $this->addObjectParser("tag", new CNTagObjectParser() );
 $this->addObjectParser("prop", new CNPropertyObjectParser() );
 }

 function getParserKey() {
 return "cntag";
 }

 function setEditMode($mode) {
 $this->d_editMode = $mode;
 }

 function _generateTags($properties, &$isend, &$hasparts, $tagcode) {
 
 
 reset($properties);
 list($prop, $value) = each($properties);
 
 
 if ($prop == "") return array(new NodeException(i18n("Tag is empty")));
 
 $type = "";
 $keyname = "";
 $props = array();
 
 
 $formats = explode(":",$prop);
 $prop = $formats[0];
 unset($formats);

 
 $parts = explode(".",$prop);
 $keyname = $parts[0];
 unset($parts[0]);

 if ($keyname == "") return array(new NodeException(i18n("Tag '{0}' has no tagname.",0, $tagcode)));
 
 if (count($formats) > 0) {
 $props["format"] = $formats;
 }
 
 if (count($parts) > 0) {
 $props["part"] = implode(".",$parts);
 }
 
 
 static $parserProps;
 if (!is_array($parserProps)) {
 $parser = $this->getObjectParser("prop");
 $parserProps = $parser->getProperties();
 }
 
 $type = ($parserProps[$keyname])? "prop" : "tag";
 
 $tag = new ParserTag($type);
 $tag->setKeyname($keyname);
 $tag->setProperties($props);

 
 if ($type == "tag" && $hasparts) {
 $obj =& $this->getBaseObject();
 $_tag =& $obj->getTag($keyname);
 if (is_a($_tag, "cntagobject")) {
 $construct =& CNConstructFactory::getConstruct($_tag->getConstructID());
 $hasparts = ($construct->needsClosingTag())?array(0):false;
 } else $hasparts = false;
 } else $hasparts = false;

 return array($tag);
 }

 function _getTagPrefixList() {
 global $TAG_PREFIX;
 $tag = $TAG_PREFIX;
 $tlen = strlen($tag) + 1;
 return array("<$tag "=>array("isend"=>false, "taglen"=>$tlen+1),
 
 "</$tag>"=>array("isend"=>true, "taglen"=>$tlen+1),
 "</$tag "=>array("isend"=>true, "taglen"=>$tlen+2) );
 }

 function _handleObject($obj) {
 if (is_a($obj, "cntagstring")) {
 $baseObj =& $this->getBaseObject();
 if (!$this->doEvaluate()) {
 
 $rs = $obj->getIconCode() . $obj->getHtml($baseObj, $this->d_editMode);
 } else {
 $rs = $obj->getHtml($baseObj, $this->d_editMode);
 }
 } else {
 $rs = $obj->toString();
 }
 return $rs;
 }

}

?>
