drop table if exists regex;
create table regex (
	id int not null primary key auto_increment,
	name_id int not null,
	desc_id int not null,
	regex text not null,
	creator int not null,
	cdate int not null,
	editor int not null,
	edate int not null,
	system int not null
) type=InnoDB;

drop table if exists tree;
create table tree (
	id int not null primary key auto_increment,
	itemorder int not null,
	mother int not null,
	name char(255) not null,
	type_id int not null
) type=InnoDB;

drop table if exists objprop;
create table objprop (
	id int not null primary key auto_increment,
	name char(255) not null,
	description char(255) not null,
	o_type int not null,
	keyword char(64) not null,
	creator int not null,
	cdate int not null,
	editor int not null,
	edate int not null
) type=InnoDB;

drop table if exists systemuser;
create table systemuser (
	id int not null primary key auto_increment,
	firstname char(255) not null,
	lastname char(255) not null,
	login char(255) not null,
	password char(127) not null,
	email char(255) not null,
	bonus int not null,
	active tinyint not null,
	creator int not null,
	cdate int not null,
	editor int not null,
	edate int not null,
	description char(255) not null,
	isldapuser int not null
) type=InnoDB;

drop table if exists perm;
create table perm (
	usergroup_id int not null,
	o_type int not null,
	o_id int not null,
	perm char(32) not null
) type=InnoDB;

drop table if exists usergroup;
create table usergroup (
	id int not null primary key auto_increment,
	name char(255) not null,
	mother int not null,
	creator int not null,
	cdate int not null,
	editor int not null,
	edate int not null,
	description char(255) not null
) type=InnoDB;

drop table if exists user_group;
create table user_group (
	user_id int not null,
	usergroup_id int not null,
	cdate int not null,
	creator int not null
) type=InnoDB;

drop table if exists logcmd;
create table logcmd (
	id int not null primary key auto_increment,
	user_id int not null,
	cmd_desc_id int not null,
	o_type int not null,
	o_id int not null,
	o_id2 int not null,
	timestamp int not null,
	info varchar(255) not null
) type=InnoDB;

drop table if exists logerror;
create table logerror (
	id int not null primary key auto_increment,
	sid char(15) not null,
	user_id int not null,
	halt_id int not null,
	request text not null,
	errordo int not null,
	timestamp int not null,
	detail text not null
) type=InnoDB;

drop table if exists halt;
create table halt (
	id int not null primary key auto_increment,
	name char(255) not null,
	description text not null
) type=InnoDB;

drop table if exists bug;
create table bug (
	id int not null primary key auto_increment,
	logerror_id int not null,
	user_id int not null,
	description text not null,
	supposed text not null,
	timestamp int not null,
	fixer char(32) not null,
	fixtime int not null

) type=InnoDB;

drop table if exists logrequest;
create table logrequest (
	id int not null primary key auto_increment,
	user_id int not null,
	request text not null,
	timestamp int not null
) type=InnoDB;

drop table if exists systemsession;
create table systemsession (
	id int not null primary key auto_increment,
	sid char(15) not null,
	user_id int not null,
	ip char(15) not null,
	agent text not null,
	cookie int not null,
	since int not null,
	language tinyint not null,
	val mediumtext not null
) type=InnoDB;

drop table if exists dicuser;
create table dicuser (
	output_id int not null,
	language_id int not null,
	value text not null
) type=InnoDB;

drop table if exists outputuser;
create table outputuser (
	id int not null primary key auto_increment,
	info int not null
) type=InnoDB;

drop table if exists language;
create table language (
	id int not null primary key auto_increment,
	name char(255)
) type=InnoDB;

drop table if exists tetris;
create table tetris (
	id int not null primary key auto_increment,
	user_id int not null,
	score int not null,
	timestamp int not null
) type=InnoDB;

drop table if exists msg;
create table msg (
	id int not null primary key auto_increment,
	from_user_id int not null,
	to_user_id int not null,
	msg text not null,
	oldmsg int not null,
	timestamp int not null
) type=InnoDB;

drop table if exists nodesetup;
create table nodesetup (
	name char(255) not null,
	intvalue int not null,
	textvalue char(255) not null
) type=InnoDB;

drop table if exists ptree;
create table ptree (
	id int not null primary key auto_increment,
	mother_id int not null,
	mother_type int not null,
	link varchar(255) not null,
	name varchar(255) not null,
	allowlink varchar(255) not null,
	folderopen varchar(255) not null,
	folderclosed varchar(255) not null,
	prepend varchar(255) not null,
	append varchar(255) not null,
	sql varchar(255) not null,
	fkt varchar(255) not null,
	bind_id int not null,
	bind_type int not null,
	linktarget char(255) not null,
	linkext text not null
) type=InnoDB;

drop table if exists logmacro;
create table logmacro (
	id int not null primary key auto_increment,
	referer int not null,
	time int not null,
	post int not null,
	request varchar(255) not null,
	vars text not null,
	frame varchar(255) not null,
	sid varchar(255) not null,
	sval text not null
) type=InnoDB;

drop table if exists workflow;
create table workflow (
	id int not null primary key auto_increment,
	name varchar(255) not null,
	description text not null,
	creator int not null,
	cdate int not null,
	editor int not null,
	edate int not null,
	o_type int not null
) type=InnoDB;

drop table if exists workflowlink;
create table workflowlink (
	id int not null primary key auto_increment,
	name varchar(255) not null,
	workflow_id int not null,
	o_type int not null,
	o_id int not null,
	creator int not null,
	cdate int not null,
	editor int not null,
	edate int not null
) type=InnoDB;

drop table if exists triggerevent;
create table triggerevent (
	id int not null primary key auto_increment,
	keyword varchar(255) not null,
	reaction_id int not null,
	active int not null,
	workflow_id int not null,
	templateevent_id int not null,
	workflowlink_id int not null
) type=InnoDB;

drop table if exists eventprop;
create table eventprop (
	id int not null primary key auto_increment,
	triggerevent_id int not null,
	keyword varchar(255) not null,
	value varchar(255) not null,
	info text not null,
	mapkey varchar(255) not null,
	workflowlink_id int not null
) type=InnoDB;

drop table if exists reaction;
create table reaction (
	id int not null primary key auto_increment,
	keyword varchar(255) not null,
	triggerevent_id int not null,
	workflow_id int not null
) type=InnoDB;

drop table if exists reactionprop;
create table reactionprop (
	id int not null primary key auto_increment,
	reaction_id int not null,
	keyword varchar(255) not null,
	value text not null,
	mapkey varchar(255) not null,
	workflowlink_id int not null
) type=InnoDB;

drop table if exists eventpropeditable;
create table eventpropeditable (
	id int not null primary key auto_increment,
	eventprop_id int not null,
	description text not null
) type=InnoDB;

drop table if exists reactionpropeditable;
create table reactionpropeditable (
	id int not null primary key auto_increment,
	reactionprop_id int not null,
	description text not null
) type=InnoDB;

drop table if exists imgresizecache;
create table imgresizecache (
	id int not null primary key auto_increment,
	filename varchar(255) not null,
	normprops text not null,
	keyprop text not null,
	cachefile varchar(255) not null
) type=InnoDB;

drop table if exists tasktemplate;
create table tasktemplate (
        id int not null primary key auto_increment,
        name varchar(255) not null,
        description text,
        command text,
        creator int not null,
        cdate int not null,
        editor int,
        edate int
) type=InnoDB;

drop table if exists tasktemplateparam;
create table tasktemplateparam (
        id int not null primary key auto_increment,
        tasktemplate_id int not null,
        paramtype int not null,
        name varchar(255) not null
) type=InnoDB;

drop table if exists task;
create table task (
        id int not null primary key auto_increment,
        tasktemplate_id int not null,
        name varchar(255),
        creator int not null,
        cdate int not null,
        editor int,
        edate int
) type=InnoDB;


drop table if exists taskparam;
create table taskparam (
        id int not null primary key auto_increment,
        task_id int not null,
        templateparam_id int not null,
		name varchar(50),
        value mediumtext
) type=InnoDB;


drop table if exists job;
create table job (
        id int not null primary key auto_increment,
        name varchar(255),
        description text,
        task_id int not null,
        schedule_type varchar(20),
        schedule_data text,
        status tinyint,
        creator int not null,
        cdate int not null,
        editor int,
        edate int
) type=InnoDB;

drop table if exists jobrun;
create table jobrun (
        id int not null primary key auto_increment,
        job_id int,
        starttime int,
        endtime int,
        returnvalue int,
        valid tinyint,
	output text
) type=InnoDB;

drop table if exists jobdependency;
create table jobdependency( 
		id int not null primary key auto_increment, 
		jobid int, 
		depid int 
) type=InnoDB;

drop table if exists dependencymap;
create table dependencymap (
  id int NOT NULL primary key auto_increment,
  mod_type int NOT NULL,
  mod_id int NOT NULL,
  mod_event_type int DEFAULT '-1',
  dep_type int NOT NULL,
  dep_id int NOT NULL,
  link_type int NOT NULL
) type=InnoDB;


drop table if exists nodecache;
create table nodecache (
	id          int not null primary key auto_increment,
	parser      varchar(127) not null,
	type        varchar(127) not null,
	keyname     varchar(255) not null,
	properties  varchar(255) not null,
	tagkey      text not null,
	input       mediumtext not null,
	output      mediumtext not null,
	lastupdate  int not null,
	reload      int not null
) type=InnoDB;

drop table if exists nodecache_object;
create table nodecache_object (
	nodecache_id    int not null,
	eventtype       int not null,
	o_id            int not null,
	o_type          int not null,
	linktype		int not null
) type=InnoDB;

drop table if exists nodecache_event;
create table nodecache_event (
	nodecache_id    int not null,
	o_id            int not null,
	o_type          int not null,
	eventtype        int not null
) type=InnoDB;

drop table if exists logevent;
create table logevent (
              id int not null primary key auto_increment,
              logevent_id int not null,
              timestamp_start int not null,
              timestamp_end int not null,
              timestamp_request int not null,
              user_id int not null,
              do int not null,
              magic int not null,
              module varchar(16) not null,
              obj_type int not null,
              obj_command varchar(32) not null,
              status int not null
) type=InnoDB;

drop table if exists loginfo;
create table loginfo (
              logevent_id int not null,
              name varchar(32) not null,
              value_int int not null,
              value_text varchar(255) not null,
              obj_type int not null,
              obj_id int not null
) type=InnoDB;

drop table if exists logquery;
create table logquery (
	timestamp int,
	do int,
	sql text,
	total int
) type=InnoDB;
